function out=COA(p,u)
% Matlab code for Algorithm 2.
% This fuction is used to generate Component Orthogonal Arrays with $m(m-1)$ runs
% and $m$ components, where $m=p^u$ with $p$ being a positive prime integer.
if isprime(p)==0
   error('The first parameter p must be a positive prime.')
end
F = gftuple([-1:p^u-2]',u,p); % Construct all the elements in GF(p^u).
G=[-Inf 0:p^u-2]; % elements in G
table=ones(p^u,1)*G;
A0=gfmul(table,table',F);
D0=A0(2:p^u,:);
D=[];
for i=1:p^u
    D=[D;gfadd(D0,G(i)*ones(p^u-1,p^u),F)];
end
COA=[];
for i=1:p^u
    [x y]=find(D==G(i));
    temp=size(x,1);
    for j=1:temp
        COA(x(j),y(j))=i-1;
    end
end
out=COA;
%tt=sortrows(COA(:,[2,3]))